/*
  CPP_CONTEST=2018Qual
  CPP_PROBLEM=F
  CPP_LANG=CUDA
  CPP_PROCESSES_PER_NODE=1
  CPP_NUM_NODES=1
*/

#include <stdlib.h>
#include <stdio.h>
#include <omp.h>
#include <iostream>
#include <iomanip>    
#include <math.h>

using namespace std;

int back(int N,int *V,bool *obtained,int num,int sum,int C1,int C2)
{
  int numsums=0; //for the number of sums

  for(int i=num+1;i<N;i++) //the number to be included in the set. Only numbers after number i
  {
     if(!obtained[sum+V[i]] and C1<=sum+V[i] and sum+V[i]<=C2) //if the number is in the range
     {
        obtained[sum+V[i]]=true; 
        numsums++;
#ifdef DEBUG
    cout << "obtained with sum: "<<sum<< " and value "<<V[i]<<endl;
#endif
     }
     numsums+=back(N,V,obtained,i,sum+V[i],C1,C2); //the remaining elements are those after number i. Parameters i and V[i] correspond to the number and the accumulated sum 
  }
  return numsums;
}

int  sec(int N,int *V,int C1,int C2)
{
  int numsums=0; //for the total number of sums
  bool *obtained=(bool *) calloc(sizeof(bool),C2); //stores the values obtained as sum of a subset of the natural numbers

  for(int i=0;i<N;i++) //the first number included in the set
  {
     if(!obtained[V[i]] and C1<=V[i] and V[i]<=C2) //if the number is in the range
     {
        obtained[V[i]]=true; 
        numsums++;
#ifdef DEBUG
    cout << "obtained with sum: 0 , and value "<<V[i]<<endl;
#endif
     }
     numsums+=back(N,V,obtained,i,V[i],C1,C2); //the remaining elements are those after number i. Parameters i and V[i] correspond to the number and the accumulated sum 
  }
  free(obtained);
  return numsums;
}

